/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/

#line 1 "cmdline.opt"
/* This file is part of Idest. -*- c -*-
   Copyright (C) 2009-2011 Sergey Poznyakoff

   Idest is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   Idest is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with Idest.  If not, see <http://www.gnu.org/licenses/>. */

static int mode_set = 0;
#define SET_MODE(m) do {                                                   \
		if (mode_set++ && mode != m)                               \
			error(1, 0, "only one of -q, -s, -d may be used"); \
		mode = m;                                                  \
	} while(0)

static unsigned
get_version_list(const char *arg)
{
	unsigned vers = 0;

	while (1) {
		switch (*arg) {
		case '1':
			vers |= IDEST_ID3V_1;
			break;
		case '2':
			vers |= IDEST_ID3V_2;
			break;
		default:
			error(1, 0, "invalid or unsupported version near %s",
			      arg);
		}
		if (*++arg == ',')
			++arg;
		else if (*arg == 0)
			break;
		else
			error(1, 0, "malformed version list near %s",
			      arg);
	}
	return vers;
}

#line 52 "cmdline.opt"

#line 52
void print_help(void);
#line 52
void print_usage(void);
#line 240 "cmdline.opt"

#line 240
/* Option codes */
#line 240
enum {
#line 240
	_OPTION_INIT=255,
#line 240
	#line 138 "cmdline.opt"

#line 138
	OPTION_LATIN1,	
#line 158 "cmdline.opt"

#line 158
	OPTION_BACKUP,	
#line 168 "cmdline.opt"

#line 168
	OPTION_BACKUP_SUFFIX,	
#line 174 "cmdline.opt"

#line 174
	OPTION_BACKUP_DIRECTORY,	
#line 180 "cmdline.opt"

#line 180
#ifdef GUILE_VERSION
#line 180
	OPTION_TRACE,
#line 180
#endif	
#line 240 "cmdline.opt"

#line 240
	OPTION_USAGE,	
#line 240 "cmdline.opt"

#line 240
	OPTION_VERSION,	

#line 240 "cmdline.opt"
	MAX_OPTION
#line 240
};
#line 240
static struct option long_options[] = {
#line 240
	#line 58 "cmdline.opt"

#line 58
	{ "query", optional_argument, 0, 'q' },
#line 66 "cmdline.opt"

#line 66
	{ "all", no_argument, 0, 'a' },
#line 73 "cmdline.opt"

#line 73
	{ "set", required_argument, 0, 's' },
#line 86 "cmdline.opt"

#line 86
	{ "delete", optional_argument, 0, 'd' },
#line 94 "cmdline.opt"

#line 94
	{ "info", no_argument, 0, 'i' },
#line 100 "cmdline.opt"

#line 100
	{ "copy", required_argument, 0, 'c' },
#line 106 "cmdline.opt"

#line 106
	{ "list-frames", no_argument, 0, 'L' },
#line 114 "cmdline.opt"

#line 114
	{ "filter", required_argument, 0, 'F' },
#line 120 "cmdline.opt"

#line 120
	{ "id-version", required_argument, 0, 'V' },
#line 126 "cmdline.opt"

#line 126
	{ "default-id-version", required_argument, 0, 'U' },
#line 132 "cmdline.opt"

#line 132
	{ "convert", required_argument, 0, 'C' },
#line 138 "cmdline.opt"

#line 138
	{ "latin1", no_argument, 0, OPTION_LATIN1 },
#line 144 "cmdline.opt"

#line 144
	{ "verbose", no_argument, 0, 'v' },
#line 150 "cmdline.opt"

#line 150
	{ "describe", no_argument, 0, 'D' },
#line 158 "cmdline.opt"

#line 158
	{ "backup", optional_argument, 0, OPTION_BACKUP },
#line 168 "cmdline.opt"

#line 168
	{ "backup-suffix", required_argument, 0, OPTION_BACKUP_SUFFIX },
#line 174 "cmdline.opt"

#line 174
	{ "backup-directory", required_argument, 0, OPTION_BACKUP_DIRECTORY },
#line 180 "cmdline.opt"

#line 180
#ifdef GUILE_VERSION
#line 180
	{ "script", required_argument, 0, 'S' },
#line 180
#endif
#line 180 "cmdline.opt"

#line 180
#ifdef GUILE_VERSION
#line 180
	{ "format", required_argument, 0, 'H' },
#line 180
#endif
#line 180 "cmdline.opt"

#line 180
#ifdef GUILE_VERSION
#line 180
	{ "batch", required_argument, 0, 'B' },
#line 180
#endif
#line 180 "cmdline.opt"

#line 180
#ifdef GUILE_VERSION
#line 180
	{ "dry-run", no_argument, 0, 'n' },
#line 180
#endif
#line 180 "cmdline.opt"

#line 180
#ifdef GUILE_VERSION
#line 180
	{ "trace", optional_argument, 0, OPTION_TRACE },
#line 180
#endif
#line 180 "cmdline.opt"

#line 180
#ifdef GUILE_VERSION
#line 180
	{ "load-path", required_argument, 0, 'P' },
#line 180
#endif
#line 180 "cmdline.opt"

#line 180
#ifdef GUILE_VERSION
#line 180
	{ "prepend-load-path", required_argument, 0, 'p' },
#line 180
#endif
#line 180 "cmdline.opt"

#line 180
#ifdef GUILE_VERSION
#line 180
	{ "no-init-files", no_argument, 0, 'N' },
#line 180
#endif
#line 240 "cmdline.opt"

#line 240
	{ "help", no_argument, 0, 'h' },
#line 240 "cmdline.opt"

#line 240
	{ "usage", no_argument, 0, OPTION_USAGE },
#line 240 "cmdline.opt"

#line 240
	{ "version", no_argument, 0, OPTION_VERSION },

#line 240 "cmdline.opt"
	{0, 0, 0, 0}
#line 240
};
#line 240
static struct opthelp {
#line 240
        const char *opt;
#line 240
        const char *arg;
#line 240
        int is_optional;
#line 240
        const char *descr;
#line 240
} opthelp[] = {
#line 240
	#line 56 "cmdline.opt"

#line 56
	{ NULL, NULL, 0, N_("Operation mode") },	
#line 60 "cmdline.opt"

#line 60
	{ "-q, --query", N_("FLIST"), 1, N_("query mode") },
#line 68 "cmdline.opt"

#line 68
	{ "-a, --all", NULL, 0, N_("query all frames") },
#line 75 "cmdline.opt"

#line 75
	{ "-s, --set", N_("FIELD=VALUE"), 0, N_("set FIELD to VALUE") },
#line 88 "cmdline.opt"

#line 88
	{ "-d, --delete", N_("FLIST"), 1, N_("delete ID3 tags") },
#line 96 "cmdline.opt"

#line 96
	{ "-i, --info", NULL, 0, N_("display information about ID3 tags") },
#line 102 "cmdline.opt"

#line 102
	{ "-c, --copy", N_("FILE"), 0, N_("copy frames from FILE") },
#line 108 "cmdline.opt"

#line 108
	{ "-L, --list-frames", NULL, 0, N_("list all supported frames") },
#line 112 "cmdline.opt"

#line 112
	{ NULL, NULL, 0, N_("Operation modifiers") },	
#line 116 "cmdline.opt"

#line 116
	{ "-F, --filter", N_("FRAME-LIST"), 0, N_("operate only on matching frames") },
#line 122 "cmdline.opt"

#line 122
	{ "-V, --id-version", N_("VERSION"), 0, N_("write new and changed tags in the given ID3 version") },
#line 128 "cmdline.opt"

#line 128
	{ "-U, --default-id-version", N_("VERSION"), 0, N_("create new tags in the given ID3 version") },
#line 134 "cmdline.opt"

#line 134
	{ "-C, --convert", N_("VERSION"), 0, N_("convert tags to VERSION") },
#line 140 "cmdline.opt"

#line 140
	{ "--latin1", NULL, 0, N_("force latin1 output") },
#line 146 "cmdline.opt"

#line 146
	{ "-v, --verbose", NULL, 0, N_("verbosely list files processed") },
#line 152 "cmdline.opt"

#line 152
	{ "-D, --describe", NULL, 0, N_("print verbose frame descriptions instead of short names") },
#line 156 "cmdline.opt"

#line 156
	{ NULL, NULL, 0, N_("Backup options") },	
#line 160 "cmdline.opt"

#line 160
	{ "--backup", N_("CONTROL"), 1, N_("backup before modifying, choose version CONTROL") },
#line 170 "cmdline.opt"

#line 170
	{ "--backup-suffix", N_("SUF"), 0, N_("set backup suffix, instead of the default ~") },
#line 176 "cmdline.opt"

#line 176
	{ "--backup-directory", N_("DIR"), 0, N_("backup to given DIR") },
#line 180 "cmdline.opt"

#line 180
#ifdef GUILE_VERSION
#line 180
	{ NULL, NULL, 0, N_("Scripting options") },
#line 180
#endif	
#line 180 "cmdline.opt"

#line 180
#ifdef GUILE_VERSION
#line 180
	{ "-S, --script", N_("FILE"), 0, N_("read Guile script from FILE; this stops further argument processing") },
#line 180
#endif
#line 180 "cmdline.opt"

#line 180
#ifdef GUILE_VERSION
#line 180
	{ "-H, --format", N_("NAME"), 0, N_("apply external format NAME; this stops further argument processing") },
#line 180
#endif
#line 180 "cmdline.opt"

#line 180
#ifdef GUILE_VERSION
#line 180
	{ "-B, --batch", N_("NAME"), 0, N_("apply batch modification module NAME; this stops further argument processing") },
#line 180
#endif
#line 180 "cmdline.opt"

#line 180
#ifdef GUILE_VERSION
#line 180
	{ "-n, --dry-run", NULL, 0, N_("run the script, print modified frames but do not write them to the file") },
#line 180
#endif
#line 180 "cmdline.opt"

#line 180
#ifdef GUILE_VERSION
#line 180
	{ "--trace", N_("LEVEL"), 1, N_("start with debugging evaluator and backtraces") },
#line 180
#endif
#line 180 "cmdline.opt"

#line 180
#ifdef GUILE_VERSION
#line 180
	{ "-P, --load-path", N_("PATH"), 0, N_("append PATH to the load path") },
#line 180
#endif
#line 180 "cmdline.opt"

#line 180
#ifdef GUILE_VERSION
#line 180
	{ "-p, --prepend-load-path", N_("PATH"), 0, N_("prepend PATH to the load path") },
#line 180
#endif
#line 180 "cmdline.opt"

#line 180
#ifdef GUILE_VERSION
#line 180
	{ "-N, --no-init-files", NULL, 0, N_("do not load Scheme init files") },
#line 180
#endif
#line 240 "cmdline.opt"

#line 240
	{ NULL, NULL, 0, N_("Other options") },	
#line 240 "cmdline.opt"

#line 240
	{ "-h, --help", NULL, 0, N_("Give this help list") },
#line 240 "cmdline.opt"

#line 240
	{ "--usage", NULL, 0, N_("Give a short usage message") },
#line 240 "cmdline.opt"

#line 240
	{ "--version", NULL, 0, N_("Print program version") },

#line 240 "cmdline.opt"
};
#line 52 "cmdline.opt"

#line 52
#include <ctype.h>
#line 52
const char *program_version = "idest" " (" PACKAGE_NAME ") " PACKAGE_VERSION;
#line 52
static char doc[] = N_("idest - ID3 Edit and Scripting Tool");
#line 52
static char args_doc[] = N_("FILE [FILE...]");
#line 52
const char *program_bug_address = "<" PACKAGE_BUGREPORT ">";
#line 52
		    
#line 52
#define DESCRCOLUMN 30
#line 52
#define RMARGIN 79
#line 52
#define GROUPCOLUMN 2
#line 52
#define USAGECOLUMN 13
#line 52
		    
#line 52
static void
#line 52
indent (size_t start, size_t col)
#line 52
{
#line 52
  for (; start < col; start++)
#line 52
    putchar (' ');
#line 52
}
#line 52
		    
#line 52
static void
#line 52
print_option_descr (const char *descr, size_t lmargin, size_t rmargin)
#line 52
{
#line 52
  while (*descr)
#line 52
    {
#line 52
      size_t s = 0;
#line 52
      size_t i;
#line 52
      size_t width = rmargin - lmargin;
#line 52

#line 52
      for (i = 0; ; i++)
#line 52
	{
#line 52
	  if (descr[i] == 0 || isspace (descr[i]))
#line 52
	    {
#line 52
	      if (i > width)
#line 52
		break;
#line 52
	      s = i;
#line 52
	      if (descr[i] == 0)
#line 52
		break;
#line 52
	    }
#line 52
	}
#line 52
      printf ("%*.*s\n", s, s, descr);
#line 52
      descr += s;
#line 52
      if (*descr)
#line 52
	{
#line 52
	  indent (0, lmargin);
#line 52
	  descr++;
#line 52
	}
#line 52
    }
#line 52
}
#line 52

#line 52
void
#line 52
print_help(void)
#line 52
{
#line 52
  unsigned i;
#line 52
  
#line 52
  printf ("%s %s [%s]... %s\n", _("Usage:"), "idest", _("OPTION"),
#line 52
	  gettext (args_doc)); 
#line 52
  if (doc[0])
#line 52
    print_option_descr(gettext (doc), 0, RMARGIN);
#line 52
  putchar ('\n');
#line 52

#line 52
  for (i = 0; i < sizeof (opthelp) / sizeof (opthelp[0]); i++)
#line 52
    {
#line 52
      unsigned n;
#line 52
      if (opthelp[i].opt)
#line 52
	{
#line 52
	  n = printf ("  %s", opthelp[i].opt);
#line 52
	  if (opthelp[i].arg)
#line 52
	    {
#line 52
	      char *cb, *ce, *sep = "";
#line 52
	      if (opthelp[i].is_optional)
#line 52
		{
#line 52
		  cb = "[";
#line 52
		  ce = "]";
#line 52
		}
#line 52
	      else
#line 52
		cb = ce = "";
#line 52

#line 52
              if (strlen (opthelp[i].opt) == 2)
#line 52
                {
#line 52
                  if (!opthelp[i].is_optional)
#line 52
                    sep = " ";
#line 52
                }
#line 52
              else
#line 52
                sep = "=";
#line 52
	      n += printf ("%s%s%s%s", cb, sep, gettext (opthelp[i].arg), ce);
#line 52
	    }
#line 52
	  if (n >= DESCRCOLUMN)
#line 52
	    {
#line 52
	      putchar ('\n');
#line 52
	      n = 0;
#line 52
	    }
#line 52
	  indent (n, DESCRCOLUMN);
#line 52
	  print_option_descr (gettext (opthelp[i].descr), DESCRCOLUMN, RMARGIN);
#line 52
	}
#line 52
      else
#line 52
	{
#line 52
	  if (i)
#line 52
	    putchar ('\n');
#line 52
	  indent (0, GROUPCOLUMN);
#line 52
	  print_option_descr (gettext (opthelp[i].descr),
#line 52
			      GROUPCOLUMN, RMARGIN);
#line 52
	  putchar ('\n');
#line 52
	}
#line 52
    }
#line 52
  
#line 52
  putchar ('\n');
#line 52
  print_option_descr (_("Mandatory or optional arguments to long options are also mandatory or optional for any corresponding short options."), 0, RMARGIN);
#line 52
  putchar ('\n');
#line 52
  printf (_("Report bugs to %s.\n"), program_bug_address);
#line 52
}
#line 52

#line 52
void
#line 52
print_usage(void)
#line 52
{
#line 52
  unsigned i;
#line 52
  int f = 0;
#line 52
  unsigned n;
#line 52
  char buf[RMARGIN+1];
#line 52

#line 52
#define FLUSH                        do                                   {                              	  buf[n] = 0;              	  printf ("%s\n", buf);    	  n = USAGECOLUMN;         	  memset (buf, ' ', n);        }                                while (0)
#line 52
#define ADDC(c)   do { if (n == RMARGIN) FLUSH; buf[n++] = c; } while (0)
#line 52

#line 52
  n = snprintf (buf, sizeof buf, "%s %s ", _("Usage:"), "idest");
#line 52

#line 52
  /* Print a list of short options without arguments. */
#line 52
  for (i = 0; i < sizeof (opthelp) / sizeof (opthelp[0]); i++)
#line 52
    {
#line 52
      if (opthelp[i].opt && opthelp[i].descr && opthelp[i].opt[1] != '-'
#line 52
	  && opthelp[i].arg == NULL)
#line 52
	{
#line 52
	  if (f == 0)
#line 52
	    {
#line 52
	      ADDC('[');
#line 52
	      ADDC('-');
#line 52
	      f = 1;
#line 52
	    }
#line 52
	  ADDC(opthelp[i].opt[1]);
#line 52
	}
#line 52
    }
#line 52
  if (f)
#line 52
    ADDC(']');
#line 52

#line 52
  /* Print a list of short options with arguments. */
#line 52
  for (i = 0; i < sizeof (opthelp) / sizeof (opthelp[0]); i++)
#line 52
    {
#line 52
      if (opthelp[i].opt && opthelp[i].descr && opthelp[i].opt[1] != '-'
#line 52
	  && opthelp[i].arg)
#line 52
	{
#line 52
	  size_t len = 5 
#line 52
	                + strlen (opthelp[i].arg)
#line 52
			   + (opthelp[i].is_optional ? 2 : 1);
#line 52
	  if (n + len > RMARGIN) FLUSH;
#line 52
	  buf[n++] = ' '; 
#line 52
	  buf[n++] = '['; 
#line 52
	  buf[n++] = '-';
#line 52
	  buf[n++] = opthelp[i].opt[1];
#line 52
	  if (opthelp[i].is_optional)
#line 52
	    {
#line 52
	      buf[n++] = '[';
#line 52
	      strcpy (&buf[n], opthelp[i].arg);
#line 52
	      n += strlen (opthelp[i].arg);
#line 52
	      buf[n++] = ']';
#line 52
	    }
#line 52
	  else
#line 52
	    {
#line 52
	      buf[n++] = ' ';
#line 52
	      strcpy (&buf[n], opthelp[i].arg);
#line 52
	      n += strlen (opthelp[i].arg);
#line 52
	    }
#line 52
	  buf[n++] = ']';
#line 52
	}
#line 52
    }
#line 52

#line 52
  /* Print a list of long options */
#line 52
  for (i = 0; i < sizeof (opthelp) / sizeof (opthelp[0]); i++)
#line 52
    {
#line 52
      if (opthelp[i].opt && opthelp[i].descr)
#line 52
	{
#line 52
	  size_t len;
#line 52
	  const char *longopt;
#line 52

#line 52
	  if (opthelp[i].opt[1] == '-')
#line 52
	    longopt = opthelp[i].opt;
#line 52
	  else if (opthelp[i].opt[2] == ',')
#line 52
	    longopt = opthelp[i].opt + 4;
#line 52
	  else
#line 52
	    continue;
#line 52

#line 52
	  len = 3 + strlen (longopt)
#line 52
	          + (opthelp[i].arg ? 1 + strlen (opthelp[i].arg)
#line 52
		      + (opthelp[i].is_optional ? 2 : 0) : 0);
#line 52
	  if (n + len > RMARGIN) FLUSH;
#line 52
	  buf[n++] = ' '; 
#line 52
	  buf[n++] = '['; 
#line 52
	  strcpy (&buf[n], longopt);
#line 52
	  n += strlen (longopt);
#line 52
	  if (opthelp[i].arg)
#line 52
	    {
#line 52
	      buf[n++] = '=';
#line 52
	      if (opthelp[i].is_optional)
#line 52
		{
#line 52
		  buf[n++] = '[';
#line 52
		  strcpy (&buf[n], opthelp[i].arg);
#line 52
		  n += strlen (opthelp[i].arg);
#line 52
		  buf[n++] = ']';
#line 52
		}
#line 52
	      else
#line 52
		{
#line 52
		  strcpy (&buf[n], opthelp[i].arg);
#line 52
		  n += strlen (opthelp[i].arg);
#line 52
		}
#line 52
	    }
#line 52
	  buf[n++] = ']';
#line 52
	}
#line 52
    }
#line 52
  FLUSH;
#line 52
  
#line 52
}
#line 52

#line 52
const char version_etc_copyright[] =
#line 52
  /* Do *not* mark this string for translation.  %s is a copyright
     symbol suitable for this locale, and %d is the copyright
     year.  */
#line 52
  "Copyright %s 2005-2011 Sergey Poznyakoff";
#line 52

#line 52
void
#line 52
print_version_only(const char *program_version, FILE *stream)
#line 52
{
#line 52
	fprintf (stream, "%s\n", program_version);
#line 52
	/* TRANSLATORS: Translate "(C)" to the copyright symbol
	   (C-in-a-circle), if this symbol is available in the user's
	   locale.  Otherwise, do not translate "(C)"; leave it as-is.  */
#line 52
	fprintf (stream, version_etc_copyright, _("(C)"));
#line 52
	fputc ('\n', stream);
#line 52
}
#line 52

#line 52
void
#line 52
print_version(const char *program_version, FILE *stream)
#line 52
{
#line 52
	print_version_only(program_version, stream);
#line 52
	
#line 52
	fputs (_("License GPLv3+: GNU GPL version 3 or later <http://gnu.org/licenses/gpl.html>\nThis is free software: you are free to change and redistribute it.\nThere is NO WARRANTY, to the extent permitted by law.\n\n"),
#line 52
	       stream);
#line 52
	
#line 52
}
#line 52

#line 240 "cmdline.opt"

#line 240


void
get_options(int argc, char *argv[])
{
	
#line 245
 {
#line 245
  int c;
#line 245
  int stop = 0;
#line 245

#line 245
  while (!stop && (c = getopt_long(argc, argv, 
#line 245
"q::"
#line 245
"a"
#line 245
"s:"
#line 245
"d::"
#line 245
"i"
#line 245
"c:"
#line 245
"L"
#line 245
"F:"
#line 245
"V:"
#line 245
"U:"
#line 245
"C:"
#line 245
"v"
#line 245
"D"
#line 245
#ifdef GUILE_VERSION
#line 245
"S:"
#line 245
#endif
#line 245

#line 245
#ifdef GUILE_VERSION
#line 245
"H:"
#line 245
#endif
#line 245

#line 245
#ifdef GUILE_VERSION
#line 245
"B:"
#line 245
#endif
#line 245

#line 245
#ifdef GUILE_VERSION
#line 245
"n"
#line 245
#endif
#line 245

#line 245
#ifdef GUILE_VERSION
#line 245
"P:"
#line 245
#endif
#line 245

#line 245
#ifdef GUILE_VERSION
#line 245
"p:"
#line 245
#endif
#line 245

#line 245
#ifdef GUILE_VERSION
#line 245
"N"
#line 245
#endif
#line 245

#line 245
"h",
#line 245
			           long_options, NULL)) != EOF)
#line 245
    {
#line 245
      switch (c)
#line 245
        {
#line 245
        default:
#line 245
	exit(1);
#line 245
       
#line 245
	#line 60 "cmdline.opt"

#line 60
	 case 'q':
#line 60
          {
#line 60

	SET_MODE(MODE_QUERY);
	if (optarg)
		parse_filter_items(optarg);

#line 64
             break;
#line 64
          }
#line 68 "cmdline.opt"

#line 68
	 case 'a':
#line 68
          {
#line 68

       SET_MODE(MODE_QUERY);
       all_frames = 1;

#line 71
             break;
#line 71
          }
#line 75 "cmdline.opt"

#line 75
	 case 's':
#line 75
          {
#line 75

       char *p;

       SET_MODE(MODE_MOD);
       p = strchr(optarg, '=');
       if (!p)
	       error(1, 0, "missing `=' sign in assignment");
       *p++ = 0;
       input_list_add_assignment(optarg, p);

#line 84
             break;
#line 84
          }
#line 88 "cmdline.opt"

#line 88
	 case 'd':
#line 88
          {
#line 88

	SET_MODE(MODE_DELETE);
	if (optarg)
		parse_filter_items(optarg);

#line 92
             break;
#line 92
          }
#line 96 "cmdline.opt"

#line 96
	 case 'i':
#line 96
          {
#line 96

	SET_MODE(MODE_INFO);

#line 98
             break;
#line 98
          }
#line 102 "cmdline.opt"

#line 102
	 case 'c':
#line 102
          {
#line 102

	source_file = optarg;

#line 104
             break;
#line 104
          }
#line 108 "cmdline.opt"

#line 108
	 case 'L':
#line 108
          {
#line 108

	SET_MODE(MODE_LIST);

#line 110
             break;
#line 110
          }
#line 116 "cmdline.opt"

#line 116
	 case 'F':
#line 116
          {
#line 116

	parse_filter_items(optarg);

#line 118
             break;
#line 118
          }
#line 122 "cmdline.opt"

#line 122
	 case 'V':
#line 122
          {
#line 122

	version_option = get_version_list(optarg);

#line 124
             break;
#line 124
          }
#line 128 "cmdline.opt"

#line 128
	 case 'U':
#line 128
          {
#line 128

	default_version_option = get_version_list(optarg);

#line 130
             break;
#line 130
          }
#line 134 "cmdline.opt"

#line 134
	 case 'C':
#line 134
          {
#line 134

	convert_version = get_version_list(optarg);

#line 136
             break;
#line 136
          }
#line 140 "cmdline.opt"

#line 140
	 case OPTION_LATIN1:
#line 140
          {
#line 140

	latin1_option = 1;

#line 142
             break;
#line 142
          }
#line 146 "cmdline.opt"

#line 146
	 case 'v':
#line 146
          {
#line 146

	verbose_option = 1;

#line 148
             break;
#line 148
          }
#line 152 "cmdline.opt"

#line 152
	 case 'D':
#line 152
          {
#line 152

	describe_option = 1;

#line 154
             break;
#line 154
          }
#line 160 "cmdline.opt"

#line 160
	 case OPTION_BACKUP:
#line 160
          {
#line 160

       if (optarg)
		backup_type = xget_version ("--backup", optarg);
       else
		backup_type = xget_version ("VERSION_CONTROL",
					    getenv("VERSION_CONTROL"));

#line 166
             break;
#line 166
          }
#line 170 "cmdline.opt"

#line 170
	 case OPTION_BACKUP_SUFFIX:
#line 170
          {
#line 170

       simple_backup_suffix = optarg;

#line 172
             break;
#line 172
          }
#line 176 "cmdline.opt"

#line 176
	 case OPTION_BACKUP_DIRECTORY:
#line 176
          {
#line 176

       backup_dir = optarg;

#line 178
             break;
#line 178
          }
#line 180 "cmdline.opt"

#line 180
#ifdef GUILE_VERSION
#line 180
	 case 'S':
#line 180
          {
#line 180

#line 180
       set_guile_argv(argc - optind, argv + optind); /* Save rest of arguments */
#line 180
       *--guile_argv = optarg;
#line 180
       optind = argc; /* Stop argument processing */
#line 180

#line 180
             break;
#line 180
          }
#line 180
#endif
#line 180 "cmdline.opt"

#line 180
#ifdef GUILE_VERSION
#line 180
	 case 'H':
#line 180
          {
#line 180

#line 180
       format_name = optarg;
#line 180
       stop = 1; /* Stop argument processing */
#line 180

#line 180
             break;
#line 180
          }
#line 180
#endif
#line 180 "cmdline.opt"

#line 180
#ifdef GUILE_VERSION
#line 180
	 case 'B':
#line 180
          {
#line 180

#line 180
       batch_name = optarg;
#line 180
       stop = 1; /* Stop argument processing */
#line 180

#line 180
             break;
#line 180
          }
#line 180
#endif
#line 180 "cmdline.opt"

#line 180
#ifdef GUILE_VERSION
#line 180
	 case 'n':
#line 180
          {
#line 180

#line 180
       dry_run_option = 1;
#line 180

#line 180
             break;
#line 180
          }
#line 180
#endif
#line 180 "cmdline.opt"

#line 180
#ifdef GUILE_VERSION
#line 180
	 case OPTION_TRACE:
#line 180
          {
#line 180

#line 180
       if (optarg)
#line 180
	       guile_debug = atoi(optarg);
#line 180
       else
#line 180
	       guile_debug = 1;
#line 180

#line 180
             break;
#line 180
          }
#line 180
#endif
#line 180 "cmdline.opt"

#line 180
#ifdef GUILE_VERSION
#line 180
	 case 'P':
#line 180
          {
#line 180

#line 180
       guile_add_load_path(optarg, 1);
#line 180

#line 180
             break;
#line 180
          }
#line 180
#endif
#line 180 "cmdline.opt"

#line 180
#ifdef GUILE_VERSION
#line 180
	 case 'p':
#line 180
          {
#line 180

#line 180
       guile_add_load_path(optarg, 0);
#line 180

#line 180
             break;
#line 180
          }
#line 180
#endif
#line 180 "cmdline.opt"

#line 180
#ifdef GUILE_VERSION
#line 180
	 case 'N':
#line 180
          {
#line 180

#line 180
       no_init_files_option = 1;
#line 180

#line 180
             break;
#line 180
          }
#line 180
#endif
#line 240 "cmdline.opt"

#line 240
	 case 'h':
#line 240
          {
#line 240

#line 240
		print_help ();
#line 240
                exit (0);
#line 240
	 
#line 240
             break;
#line 240
          }
#line 240 "cmdline.opt"

#line 240
	 case OPTION_USAGE:
#line 240
          {
#line 240

#line 240
		print_usage ();
#line 240
		exit (0);
#line 240
	 
#line 240
             break;
#line 240
          }
#line 240 "cmdline.opt"

#line 240
	 case OPTION_VERSION:
#line 240
          {
#line 240

#line 240
		/* Give version */
#line 240
		print_version(program_version, stdout);
#line 240
		exit (0);
#line 240
         
#line 240
             break;
#line 240
          }

#line 245 "cmdline.opt"
        }
#line 245
    }
#line 245
 }   
#line 245

	if (optind < argc && mode == MODE_MOD) {
		char *p;
		/* See if we've been given any assignment arguments */
		while (argv[optind] && (p = strchr(argv[optind], '='))) {
			*p++ = 0;
			input_list_add_assignment(argv[optind++], p);
		}
	}
}
